/* graphic.pl */
/* vt100 escape sequences */

/* Cursor Home 		<ESC>[{ROW};{COLUMN}H */
cpos(X,Y) :- put(27),put(91),!,
             cposx(X),
             put(59),!,
             cposx(Y),put(72).

cposx(X) :- X < 9, Y is X + 48, put(Y).
cposx(X) :- Y1 is X mod 10, 
            Y11 is X - Y1,
            Z is Y11 / 10 + 48,
            Z1 is Y1 + 48,
            put(Z),put(Z1).

/* Cursor Home 		<ESC>[H */
chome :- put(27),put(91),put(72).

/* Cursor Up		<ESC>[{COUNT}A */
cup :- put(27),put(91),put(49),put(65).

/* Cursor Down		<ESC>[{COUNT}B */
cdown :- put(27),put(91),put(49),put(66).

/* Cursor Forward	<ESC>[{COUNT}C */
cfw :- put(27),put(91),put(49),put(67).

/* Cursor Forward	<ESC>[{COUNT}C */
cfw(X) :- X < 9, Y is X + 48,put(27),put(91),put(Y),put(67).
cfw(X) :- Y1 is X mod 10, 
          Y11 is X - Y1,
          Z is Y11 / 10 + 48,
          Z1 is Y1 + 48,
          put(27),put(91),put(Z),put(Z1),put(67).

/* Cursor Backward	<ESC>[{COUNT}D */
cbw :- put(27),put(91),put(49),put(68).

/* Erase Screen		<ESC>[2J */
clears :- put(27),put(91),put(50), put(74).

/* erase in line */

/* Erase End of Line	<ESC>[K */
delcline :- put(27),put(91),put(75).   /* loescht vom cursor bis   */
                                       /* zeilenende               */
/* Erase Start of Line	<ESC>[1K */
delsline :- put(27),put(91),put(49),put(75).   /* loescht vom zeilenanfang */
                                               /* bis cursor               */
/* Erase Line		<ESC>[2K */
delline :- put(27),put(91),put(50),put(75).    /* loescht zeile            */

/* select graphic rendition , IBM attributes */
/* Set Attribute Mode	<ESC>[{attr1};...;{attrn}m */
charattr(off) :- put(27),put(91),put(48),put(109).
charattr(bold) :- put(27),put(91),put(49),put(109).
charattr(subscript) :- put(27),put(91),put(50),put(109).
charattr(superscript) :- put(27),put(91),put(51),put(109).
charattr(underscore) :- put(27),put(91),put(52),put(109).
charattr(blinking) :- put(27),put(91),put(53),put(109).
charattr(overscore) :- put(27),put(91),put(54),put(109).
charattr(reverse) :- put(27),put(91),put(55),put(109).
charattr(invisible) :- put(27),put(91),put(56),put(109).

