/* knight.pdb  AP  12-jan-89 */
/* knighter's tour */

?- reconsult(graphic).

generate(X) :- LeftCornerX is 40 - 2 * X,
               LeftCornerY is 10 - X,
               assert(topleft(LeftCornerX,LeftCornerY)),
               MaxSteps is X * X,
               assert(maxsteps(MaxSteps)),
               genx(X,X).                     /* (X * X) - Feld generieren */

genx(0,_).
genx(X,Y) :- geny(X,Y), 
             X1 is X - 1,
             genx(X1,Y).

geny(_,0).
geny(X,Y) :- /* not(field(X,Y)),*/
             assert(field(X,Y)),
             Y1 is Y - 1,
             geny(X,Y1).
geny(X,Y) :- Y1 is Y - 1,
             geny(X,Y1).

add(X,[],[X]).
add(X,Y,[X|Y]).

is_in(X,[X|_]).
is_in(X,[_|Z]) :- is_in(X,Z).

setpos(X,Y) :- topleft(Tx,Ty),
               X1 is Tx + 4 * (X - 1),
               Y1 is Ty + 2 * (Y - 1),
               cpos(Y1,X1), !.

writen(X,Y) :- setpos(X,Y), write('*').
writen(X,Y) :- setpos(X,Y), write(' '), fail.

writeo(X,Y) :- setpos(X,Y), write('.').
writeo(X,Y) :- setpos(X,Y), write('*'), fail.


try(pos(X,Y),L,Len) :-
        X1 is X + 1, Y1 is Y + 2,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(X,Y),L,Len) :-
        X1 is X + 2, Y1 is Y + 1,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(X,Y),L,Len) :-
        X1 is X + 2, Y1 is Y - 1,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(X,Y),L,Len) :-
        X1 is X + 1, Y1 is Y - 2,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(X,Y),L,Len) :-
        X1 is X - 1, Y1 is Y - 2,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(X,Y),L,Len) :-
        X1 is X - 2, Y1 is Y - 1,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(X,Y),L,Len) :-
        X1 is X - 2, Y1 is Y + 1,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(X,Y),L,Len) :-
        X1 is X - 1, Y1 is Y + 2,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(_,_),_,Len) :-
                   maxsteps(Len),        /* Abbruchbedingung */
                   cpos(22,1).

knight :- chome, clears,
          write('  springer tour :  enter brettgroesse : '),
          read(Size), nl,
          write('                   enter startposition (X, Y) : '),
          read(X), read(Y),
          X =< Size, Y =< Size,
          retractall(field),
          retractall(maxsteps),
          retractall(topleft),
          generate(Size),
          writen(X,Y),
          try(pos(X,Y),[pos(X,Y)],1).

