/* raetsel.pl */

/* jeder Buchstabe steht für eine Ziffer

 ABB -  CD = EED
  -     -     *
  FD +  EF =  CE
  =     =     =
 EGD *  FH = ???  

**************************************/

gen(A,B,C,D,E,F,G,H) :-
	permutation([A,B,C,D,E,F,G,H,_,_],[0,1,2,3,4,5,6,7,8,9]).

/* Die Gleichungen */
gl1(A,B,C,D,E) :-
	 ((A * 100 + B * 10 + B) - (C * 10 + D)) =:= (E * 100 + E * 10 + D).
gl2(C,D,E,F) :-
	((F * 10 + D) + (E * 10 + F)) =:= (C * 10 + E).
gl3(A,B,D,E,F,G) :-
	((A * 100 + B * 10 + B) - (F * 10 + D)) =:= (E * 100 + G * 10 + D).
gl4(C,D,E,F,H) :-
	((C * 10 + D) - (E * 10 + F)) =:= (F * 10 + H).
gl5(C,D,E,F,G,H,X) :-
	((E * 100 + E * 10 + D) * (C * 10 + E)) =:=
	((E * 100 + G * 10 + D) * (F * 10 + H)),
	X is ((E * 100 + G * 10 + D) * (F * 10 + H)).

/* Die Lösungsregel - systematisches Probieren */
loesung :- 
	write('Das Problem:'), nl,
	prettyprint(a, b, c, d, e, f, g, h, '???'),
	gen(A,B,C,D,E,F,G,H),
	gl1(A,B,C,D,E), gl2(C,D,E,F),
        gl3(A,B,D,E,F,G), gl4(C,D,E,F,H),
	gl5(C,D,E,F,G,H,X),
	nl, write('Die Lösung: '), nl,
	prettyprint(A, B, C, D, E, F, G, H, X ).

prettyprint(A, B, C, D, E, F, G, H, X ) :-
 	/* ABB -  CD = EED */
	write(A), write(B), write(B), write(' - '),
	write(C), write(D), write(' = '),
	write(E), write(E), write(D), nl,
	/*  -    -     * */
	write(' -    -     * '), nl,
  	/* FD +  EF =  CE */
	write(' '), write(F), write(D), write(' + '),
	write(E), write(F), write(' = '),
	write(' '), write(C), write(E), nl,
	/*  =     =     = */
	write(' =    =     = '), nl, 
 	/* EGD *  FH = ???  */
	write(E), write(G), write(D), write(' * '),
	write(F), write(H), write(' = '),
	write(X), nl.
